/**
 * 
 */
package ex1;

import java.util.Properties;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderError;
import org.drools.builder.KnowledgeBuilderErrors;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.compiler.PackageBuilderConfiguration;
import org.drools.io.Resource;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;

import ex1.model.User;

/**
 * @author harpreet.singh
 * 
 */
public class TestNotMatchesOperator {

	private static final String xdrlPath = "ex1/User.xml";

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TestNotMatchesOperator m = new TestNotMatchesOperator();
		m.runTest(xdrlPath);
	}

	public void runTest(String path) {


		final Properties properties = new Properties();
		properties.setProperty("drools.dialect.java.compiler", "JANINO");
		properties.setProperty("drools.dialect.mvel.strict", "false");
		final PackageBuilderConfiguration knwBuilderCfg = new PackageBuilderConfiguration(
				properties);
		
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory
				.newKnowledgeBuilder(knwBuilderCfg);
		Resource xdrlFile = ResourceFactory.newClassPathResource( path, getClass() );
		kbuilder.add(xdrlFile, ResourceType.XDRL);

		// check for error's if any
		 if( kbuilder.hasErrors() ){
		      System.err.println( "Compilation Errors......" );
		      KnowledgeBuilderErrors errors = kbuilder.getErrors();
		      int i = 1;
		      for( KnowledgeBuilderError err: errors ){
			  System.err.println( "Error no " + i + "-" + err.toString() );
			  i++;
		      }
		      return;
		  }

		KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
		kbase.addKnowledgePackages(kbuilder.getKnowledgePackages());
		StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();

		// Create and Put the objects into the working memory
		User user = new User("donald", "duck");
		// insert the object/fact into the working memory....
		ksession.insert(user);// 
		System.out.println("Fire.....");
		ksession.fireAllRules();
		ksession.dispose();
		System.out.println("Finish....");
	}
}
